let _ = Mltop.add_known_module "coq-elpi.elpi"

# 7 "src/coq_elpi_vernacular_syntax.mlg"
 

open Stdarg
open Ltac_plugin

open Pcoq.Constr

open Coq_elpi_arg_syntax
module EV = Coq_elpi_vernacular
module EA = Coq_elpi_arg_HOAS
module U = Coq_elpi_utils




# 23 "src/coq_elpi_vernacular_syntax.mlg"
 
let pr_elpi_code _ _ _ (s : Elpi.API.Ast.Loc.t * string) = Pp.str (snd s)


let (wit_elpi_code, elpi_code) = Tacentries.argument_extend ~plugin:"coq-elpi.elpi" ~name:"elpi_code" 
                                 {
                                 Tacentries.arg_parsing = Vernacextend.Arg_rules (
                                                          []);
                                 Tacentries.arg_tag = None;
                                 Tacentries.arg_intern = Tacentries.ArgInternFun (fun ist v -> (ist, v));
                                 Tacentries.arg_subst = Tacentries.ArgSubstFun (fun s v -> v);
                                 Tacentries.arg_interp = Tacentries.ArgInterpRet;
                                 Tacentries.arg_printer = ((fun env sigma -> 
                                                          
# 28 "src/coq_elpi_vernacular_syntax.mlg"
                 pr_elpi_code 
                                                          ), (fun env sigma -> 
                                                          
# 28 "src/coq_elpi_vernacular_syntax.mlg"
                 pr_elpi_code 
                                                          ), (fun env sigma -> 
                                                          
# 28 "src/coq_elpi_vernacular_syntax.mlg"
                 pr_elpi_code 
                                                          ));
                                 }
let _ = (wit_elpi_code, elpi_code)


# 30 "src/coq_elpi_vernacular_syntax.mlg"
 
let () = Coq_elpi_glob_quotation.is_elpi_code :=
           (fun x -> Genarg.(has_type x (glbwit wit_elpi_code)))
let () = Coq_elpi_glob_quotation.get_elpi_code :=
           (fun x -> Genarg.(out_gen (glbwit wit_elpi_code) x))

let pr_elpi_code_appArg _ _ _ (s : Elpi.API.Ast.Loc.t * string list) = Pp.prlist Pp.str (snd s)


let (wit_elpi_code_appArg, elpi_code_appArg) = Tacentries.argument_extend ~plugin:"coq-elpi.elpi" ~name:"elpi_code_appArg" 
                                               {
                                               Tacentries.arg_parsing = 
                                               Vernacextend.Arg_rules (
                                               []);
                                               Tacentries.arg_tag = None;
                                               Tacentries.arg_intern = 
                                               Tacentries.ArgInternFun (fun ist v -> (ist, v));
                                               Tacentries.arg_subst = 
                                               Tacentries.ArgSubstFun (fun s v -> v);
                                               Tacentries.arg_interp = 
                                               Tacentries.ArgInterpRet;
                                               Tacentries.arg_printer = 
                                               ((fun env sigma -> 
# 40 "src/coq_elpi_vernacular_syntax.mlg"
               pr_elpi_code_appArg 
                                               ), (fun env sigma -> 
# 40 "src/coq_elpi_vernacular_syntax.mlg"
               pr_elpi_code_appArg 
                                               ), (fun env sigma -> 
# 40 "src/coq_elpi_vernacular_syntax.mlg"
               pr_elpi_code_appArg 
                                               ));
                                               }
let _ = (wit_elpi_code_appArg, elpi_code_appArg)


# 42 "src/coq_elpi_vernacular_syntax.mlg"
 

let () = Coq_elpi_glob_quotation.is_elpi_code_appArg  :=
           (fun x -> Genarg.(has_type x (glbwit wit_elpi_code_appArg )))
let () = Coq_elpi_glob_quotation.get_elpi_code_appArg  :=
           (fun x -> Genarg.(out_gen (glbwit wit_elpi_code_appArg ) x))

let rec inlogpath q = function
  | [] -> []
  | x :: xs -> ("coq://" ^ Libnames.string_of_qualid q ^ "/" ^ x) :: inlogpath q xs

let warning_legacy_accumulate_gen =
  CWarnings.create ~default:CWarnings.AsError ~name:"elpi.accumulate-syntax" ~category:Coq_elpi_utils.elpi_depr_cat (fun has_from ->
      if has_from then
        Pp.strbrk "The syntax 'Elpi Accumulate File \"path\"' is deprecated, use 'Elpi Accumulate File \"path\" From logpath'"
      else Pp.strbrk "The syntax 'Elpi Accumulate File \"path\" From logpath' is deprecated, use 'From logpath Extra Dependency \"path\" as name. Elpi Accumulate File name.'")

let warning_legacy_accumulate ?loc () = warning_legacy_accumulate_gen ?loc true
let warning_legacy_accumulate2 ?loc () = warning_legacy_accumulate_gen ?loc false

let lib_ref id =
  let id = String.concat "." (snd id) in
  try Coqlib.lib_ref id
  with Coqlib.NotFoundRef _ ->
    CErrors.user_err
      Pp.(str "Global reference not found: lib:" ++ str id
          ++ str " (you may need to require some .v file with \
                  `Register ... as " ++ str id ++ str ".`).")



let _ = let () =
        Egramml.grammar_extend ~plugin_uid:("coq-elpi.elpi", "coq_elpi_vernacular_syntax.mlg:0")
        term
        (Pcoq.Reuse (Some
        ("0"), [Pcoq.Production.make
                (Pcoq.Rule.next (Pcoq.Rule.stop)
                                ((Pcoq.Symbol.token (Tok.PQUOTATION "lp:"))))
                (fun s loc -> 
# 76 "src/coq_elpi_vernacular_syntax.mlg"
          
          let loc = { loc with Loc.bp = loc.Loc.bp + 3 } in
          let arg =
            if s.[0] = '('
            then Genarg.in_gen (Genarg.rawwit wit_elpi_code_appArg) (idents_of loc s)
            else if s.[0] = '\123'
            then Genarg.in_gen (Genarg.rawwit wit_elpi_code) (strip_curly loc s)
            else Genarg.in_gen (Genarg.rawwit wit_elpi_code) (Coq_elpi_utils.of_coq_loc loc,s) in
          CAst.make ~loc
            (Constrexpr.CGenarg arg) 
                              )]))
        in ()

let _ = let () =
        Egramml.grammar_extend ~plugin_uid:("coq-elpi.elpi", "coq_elpi_vernacular_syntax.mlg:1")
        term
        (Pcoq.Reuse (Some
        ("0"), [Pcoq.Production.make
                (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.next 
                                                                (Pcoq.Rule.stop)
                                                                ((Pcoq.Symbol.token (Tok.PKEYWORD ("lib")))))
                                                                ((Pcoq.Symbol.token (Tok.PKEYWORD (":")))))
                                                ((Pcoq.Symbol.token (Tok.PKEYWORD ("@")))))
                                ((Pcoq.Symbol.nterm qualified_name)))
                (fun id _ _ _ loc -> 
# 98 "src/coq_elpi_vernacular_syntax.mlg"
                                                 
          let ref = lib_ref id in
          let path = Nametab.path_of_global ref in
          let f = Libnames.qualid_of_path ~loc:(fst id) path in
          CAst.make ~loc Constrexpr.(CAppExpl((f,None),[])) 
                                     );
               Pcoq.Production.make
               (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.stop)
                                                               ((Pcoq.Symbol.token (Tok.PKEYWORD ("lib")))))
                                               ((Pcoq.Symbol.token (Tok.PKEYWORD (":")))))
                               ((Pcoq.Symbol.nterm qualified_name)))
               (fun id _ _ loc -> 
# 94 "src/coq_elpi_vernacular_syntax.mlg"
                                            
          let ref = lib_ref id in
          let path = Nametab.path_of_global ref in
          CAst.make ~loc Constrexpr.(CRef (Libnames.qualid_of_path ~loc:(fst id) path,None)) 
                                  )]))
        in ()


# 108 "src/coq_elpi_vernacular_syntax.mlg"
 
let classify_named_vernac (_,p) = Vernacextend.VtSideff([Names.Id.of_string_soft @@ String.concat "." p],VtNow)


let () = Vernacextend.static_vernac_extend ~plugin:(Some "coq-elpi.elpi") ~command:"ElpiNamed"  ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                     Vernacextend.TyTerminal ("Program", 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                     Vernacextend.TyNil)))), (let coqpp_body p
                                                             s
                                                             atts = (let atts = 
                                                                    
# 114 "src/coq_elpi_vernacular_syntax.mlg"
     
     let atts = validate_attributes raw_args_attributes atts in
     EV.Synterp.create_program ~atts ~init:s p;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 118 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_program ~atts ~init:s p
   
                                                                    )) in fun p
                                                             s ?loc ~atts ()
                                                             -> coqpp_body p
                                                             s
                                                             (Attributes.parse any_attribute atts)), Some 
         (fun p s -> 
# 113 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                       classify_named_vernac p 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Command", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           atts = (let atts = 
                                                                  
# 122 "src/coq_elpi_vernacular_syntax.mlg"
     
     let atts = validate_attributes raw_args_attributes atts in
     EV.Synterp.create_command ~atts p;
     atts
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 126 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_command ~atts p 
                                                                  )) in fun p
                                                           ?loc ~atts ()
                                                           -> coqpp_body p
                                                           (Attributes.parse any_attribute atts)), Some 
         (fun p -> 
# 121 "src/coq_elpi_vernacular_syntax.mlg"
                                                                        classify_named_vernac p 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Tactic", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           atts = (let _ = 
                                                                  
# 129 "src/coq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     EV.Synterp.create_tactic p
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 132 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_tactic p 
                                                                  )) in fun p
                                                           ?loc ~atts ()
                                                           -> coqpp_body p
                                                           (Attributes.parse any_attribute atts)), Some 
         (fun p -> 
# 128 "src/coq_elpi_vernacular_syntax.mlg"
                                                                       classify_named_vernac p 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                                                   Vernacextend.TyNil)))), 
         (let coqpp_body d s
         atts = (let atts = 
# 135 "src/coq_elpi_vernacular_syntax.mlg"
     
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.create_db ~atts d ~init:s;
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 139 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_db ~atts d ~init:s 
                )) in fun d
         s ?loc ~atts () -> coqpp_body d s
         (Attributes.parse any_attribute atts)), Some (fun d s -> 
# 134 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                  classify_named_vernac d 
                                                      )))]

let () = Vernacextend.static_vernac_extend ~plugin:(Some "coq-elpi.elpi") ~command:"ElpiUnnamed" ~classifier:(fun _ -> Vernacextend.classify_as_sideeff) ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                     Vernacextend.TyTerminal ("Accumulate", 
                                     Vernacextend.TyTerminal ("File", 
                                     Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                 Extend.TUentry (Genarg.get_arg_tag wit_ident)), 
                                     Vernacextend.TyNil)))), (let coqpp_body ids
                                                             atts = (let atts = 
                                                                    
# 144 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                               
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts  ids;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 148 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts  ids 
                                                                    )) in fun ids
                                                             ?loc ~atts ()
                                                             -> coqpp_body ids
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_ident)), 
                                    Vernacextend.TyNil)))), (let coqpp_body ids
                                                            atts = (let atts = 
                                                                   
# 150 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts  ids;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 154 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts  ids 
                                                                   )) in fun ids
                                                            ?loc ~atts ()
                                                            -> coqpp_body ids
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_ident)), 
                                    Vernacextend.TyNil))))), (let coqpp_body p
                                                             ids
                                                             atts = (let atts = 
                                                                    
# 156 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                                 
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts  ~program:(snd p) ids;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 160 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts  ~program:(snd p) ids 
                                                                    )) in fun p
                                                             ids
                                                             ?loc ~atts ()
                                                             -> coqpp_body p
                                                             ids
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_ident)), 
                                    Vernacextend.TyNil))))), (let coqpp_body p
                                                             ids
                                                             atts = (let atts = 
                                                                    
# 162 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                                  
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts  ~program:(snd p) ids;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 166 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts  ~program:(snd p) ids 
                                                                    )) in fun p
                                                             ids
                                                             ?loc ~atts ()
                                                             -> coqpp_body p
                                                             ids
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))), (let coqpp_body s
                                                            atts = (let atts = 
                                                                   
# 169 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                            warning_legacy_accumulate ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 173 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  s 
                                                                   )) in fun s
                                                            ?loc ~atts ()
                                                            -> coqpp_body s
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil)))))), (let coqpp_body s
                                                              g
                                                              atts = 
                                                              (let atts = 
                                                              
# 175 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                             warning_legacy_accumulate2 ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  (inlogpath g s);
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 179 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  (inlogpath g s) 
                                                              )) in fun s g
                                                              ?loc ~atts ()
                                                              -> coqpp_body s
                                                              g
                                                              (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))), (let coqpp_body s
                                                            atts = (let atts = 
                                                                   
# 181 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                             warning_legacy_accumulate ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 185 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  s 
                                                                   )) in fun s
                                                            ?loc ~atts ()
                                                            -> coqpp_body s
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil)))))), (let coqpp_body s
                                                              g
                                                              atts = 
                                                              (let atts = 
                                                              
# 187 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                              warning_legacy_accumulate2 ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  (inlogpath g s);
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 191 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  (inlogpath g s) 
                                                              )) in fun s g
                                                              ?loc ~atts ()
                                                              -> coqpp_body s
                                                              g
                                                              (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                    Vernacextend.TyNil))), (let coqpp_body s
                                                           atts = (let atts = 
                                                                  
# 193 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                    
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_string ~atts  s;
     atts
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 197 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_string ~atts  s 
                                                                  )) in fun s
                                                           ?loc ~atts ()
                                                           -> coqpp_body s
                                                           (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body p
                                                             s
                                                             atts = (let atts = 
                                                                    
# 199 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                              warning_legacy_accumulate ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  ~program:(snd p) s;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 203 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  ~program:(snd p) s 
                                                                    )) in fun p
                                                             s ?loc ~atts ()
                                                             -> coqpp_body p
                                                             s
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil))))))), (let coqpp_body p
                                                               s g
                                                               atts = 
                                                               (let atts = 
                                                               
# 205 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                                               warning_legacy_accumulate2 ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  ~program:(snd p) (inlogpath g s);
     atts
   
                                                                in Vernactypes.vtdefault (fun () -> 
                                                               
# 209 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  ~program:(snd p) (inlogpath g s) 
                                                               )) in fun p s
                                                               g
                                                               ?loc ~atts ()
                                                               -> coqpp_body p
                                                               s g
                                                               (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body p
                                                             s
                                                             atts = (let atts = 
                                                                    
# 211 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                               warning_legacy_accumulate ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  ~program:(snd p) s;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 215 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  ~program:(snd p) s 
                                                                    )) in fun p
                                                             s ?loc ~atts ()
                                                             -> coqpp_body p
                                                             s
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil))))))), (let coqpp_body p
                                                               s g
                                                               atts = 
                                                               (let atts = 
                                                               
# 217 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                                                warning_legacy_accumulate2 ();
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts  ~program:(snd p) (inlogpath g s);
     atts
   
                                                                in Vernactypes.vtdefault (fun () -> 
                                                               
# 221 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts  ~program:(snd p) (inlogpath g s) 
                                                               )) in fun p s
                                                               g
                                                               ?loc ~atts ()
                                                               -> coqpp_body p
                                                               s g
                                                               (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                    Vernacextend.TyNil)))), (let coqpp_body p
                                                            s
                                                            atts = (let atts = 
                                                                   
# 223 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                      
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_string ~atts  ~program:(snd p) s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 227 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_string ~atts  ~program:(snd p) s 
                                                                   )) in fun p
                                                            s ?loc ~atts ()
                                                            -> coqpp_body p s
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil)))), 
         (let coqpp_body d
         atts = (let atts = 
# 229 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                            
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_db ~atts  (snd d);
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 233 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_db ~atts  (snd d) 
                )) in fun d
         ?loc ~atts () -> coqpp_body d (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil))))), 
         (let coqpp_body p d
         atts = (let atts = 
# 235 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                               
     let atts = validate_attributes skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_db ~atts  ~program:(snd p) (snd d);
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 239 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_db ~atts  ~program:(snd p) (snd d) 
                )) in fun p
         d ?loc ~atts () -> coqpp_body p d
         (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Debug", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))), (let coqpp_body s
                                                           atts = (let atts = 
                                                                  
# 242 "src/coq_elpi_vernacular_syntax.mlg"
                                                                               
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.debug  ~atts s;
     atts
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 246 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.debug  ~atts s 
                                                                  )) in fun s
                                                           ?loc ~atts ()
                                                           -> coqpp_body s
                                                           (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyTerminal ("Browser", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))), (let coqpp_body s
                                                            atts = (let atts = 
                                                                   
# 248 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                         
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace_browser  ~atts s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 252 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace_browser  ~atts s 
                                                                   )) in fun s
                                                            ?loc ~atts ()
                                                            -> coqpp_body s
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))), (let coqpp_body s
                                                           atts = (let atts = 
                                                                  
# 254 "src/coq_elpi_vernacular_syntax.mlg"
                                                                               
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts 1 max_int s [];
     atts
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 258 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace  ~atts 1 max_int s [] 
                                                                  )) in fun s
                                                           ?loc ~atts ()
                                                           -> coqpp_body s
                                                           (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("/", Vernacextend.TyNonTerminal (
                                                                  Extend.TUlist0 (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                                                  Vernacextend.TyNil))))), 
         (let coqpp_body s o
         atts = (let atts = 
# 260 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                  
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts 1 max_int s o;
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 264 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace ~atts 1 max_int s o 
                )) in fun s
         o ?loc ~atts () -> coqpp_body s o
         (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body start
                                                             stop s
                                                             atts = (let atts = 
                                                                    
# 266 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                      
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts start stop s [];
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 270 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace ~atts start stop s [] 
                                                                    )) in fun start
                                                             stop s
                                                             ?loc ~atts ()
                                                             -> coqpp_body start
                                                             stop s
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("/", Vernacextend.TyNonTerminal (
                                                                  Extend.TUlist0 (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                                                  Vernacextend.TyNil))))))), 
         (let coqpp_body start stop s o
         atts = (let atts = 
# 272 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                                       
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts start stop s o;
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 276 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace  ~atts start stop s o 
                )) in fun start
         stop s o ?loc ~atts () -> coqpp_body start stop s o
         (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyTerminal ("Off", Vernacextend.TyNil))), 
         (let coqpp_body atts = (let atts = 
# 279 "src/coq_elpi_vernacular_syntax.mlg"
                                                                      
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts 0 0 [] [];
     atts
   
                                 in Vernactypes.vtdefault (fun () -> 
                                
# 283 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace  ~atts 0 0 [] [] 
                                )) in fun ?loc ~atts ()
         -> coqpp_body (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Bound", 
                                    Vernacextend.TyTerminal ("Steps", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNil)))), (let coqpp_body steps
                                                            atts = (let atts = 
                                                                   
# 285 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                   
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.bound_steps  ~atts steps;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 289 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.bound_steps  ~atts steps 
                                                                   )) in fun steps
                                                            ?loc ~atts ()
                                                            -> coqpp_body steps
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Print", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))), (let coqpp_body p
                                                            s
                                                            atts = (let atts = 
                                                                   
# 292 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                 
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.print ~atts (snd p) s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 296 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.print  ~atts (snd p) s 
                                                                   )) in fun p
                                                            s ?loc ~atts ()
                                                            -> coqpp_body p s
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Typecheck", 
                                    Vernacextend.TyNil)), (let coqpp_body atts = 
                                                          (let _ = 
# 300 "src/coq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     EV.Synterp.typecheck_program ()
   
                                                           in Vernactypes.vtdefault (fun () -> 
                                                          
# 303 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.typecheck_program () 
                                                          )) in fun ?loc ~atts ()
                                                          -> coqpp_body (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Typecheck", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           atts = (let _ = 
                                                                  
# 306 "src/coq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     EV.Synterp.typecheck_program ~program:(snd p) ()
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 309 "src/coq_elpi_vernacular_syntax.mlg"
         
     let () = ignore_unknown_attributes atts in
     EV.Interp.typecheck_program ~program:(snd p) () 
                                                                  )) in fun p
                                                           ?loc ~atts ()
                                                           -> coqpp_body p
                                                           (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Document", 
                                    Vernacextend.TyTerminal ("Builtins", 
                                    Vernacextend.TyNil))), (let coqpp_body atts = 
                                                           Vernactypes.vtdefault (fun () -> 
                                                           
# 313 "src/coq_elpi_vernacular_syntax.mlg"
                                                                 
     let () = ignore_unknown_attributes atts in
     EV.document_builtins () 
                                                           ) in fun ?loc ~atts ()
                                                           -> coqpp_body (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Checker", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil)))), (let coqpp_body syn
                                                            int
                                                            atts = (let _ = 
                                                                   
# 316 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                       
     let () = ignore_unknown_attributes atts in
     EV.Synterp.load_checker syn
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 319 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.load_checker int 
                                                                   )) in fun syn
                                                            int ?loc ~atts ()
                                                            -> coqpp_body syn
                                                            int
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Printer", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil)))), (let coqpp_body syn
                                                            int
                                                            atts = (let _ = 
                                                                   
# 321 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                       
     let () = ignore_unknown_attributes atts in
     EV.Synterp.load_printer syn
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 324 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.load_printer int 
                                                                   )) in fun syn
                                                            int ?loc ~atts ()
                                                            -> coqpp_body syn
                                                            int
                                                            (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Template", 
                                    Vernacextend.TyTerminal ("Command", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil))))), (let coqpp_body syn
                                                             int
                                                             atts = (let _ = 
                                                                    
# 326 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                  
     let () = ignore_unknown_attributes atts in
     EV.Synterp.load_command syn
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 329 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.load_command int 
                                                                    )) in fun syn
                                                             int
                                                             ?loc ~atts ()
                                                             -> coqpp_body syn
                                                             int
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Template", 
                                    Vernacextend.TyTerminal ("Tactic", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil)))), (let coqpp_body s
                                                            atts = (let _ = 
                                                                   
# 331 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                   
     let () = ignore_unknown_attributes atts in
     () (* no synterp tactics  EV.Synterp.load_tactic syn *)
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 334 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.load_tactic s 
                                                                   )) in fun s
                                                            ?loc ~atts ()
                                                            -> coqpp_body s
                                                            (Attributes.parse any_attribute atts)), None))]

let () = Vernacextend.static_vernac_extend ~plugin:(Some "coq-elpi.elpi") ~command:"ElpiRun" ~classifier:( fun _ -> Vernacextend.(VtSideff ([], VtNow)) ) ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                     Vernacextend.TyTerminal ("Query", 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                     Vernacextend.TyNonTerminal (Extend.TUopt (
                                                                 Extend.TUentry (Genarg.get_arg_tag wit_elpi_string)), 
                                     Vernacextend.TyNil)))), (let coqpp_body synterp
                                                             interp
                                                             atts = (let syndata = 
                                                                    
# 340 "src/coq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     match synterp with
     | Some synterp -> EV.Synterp.run_in_program synterp
     | None -> None
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 346 "src/coq_elpi_vernacular_syntax.mlg"
         
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     EV.Interp.run_in_program ~syndata interp 
                                                                    )) in fun synterp
                                                             interp
                                                             ?loc ~atts ()
                                                             -> coqpp_body synterp
                                                             interp
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Query", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUopt (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_elpi_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body p
                                                             synterp interp
                                                             atts = (let syndata = 
                                                                    
# 350 "src/coq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     match synterp with
     | Some synterp -> EV.Synterp.run_in_program synterp
     | None -> None
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 356 "src/coq_elpi_vernacular_syntax.mlg"
         
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     EV.Interp.run_in_program ~program:(snd p) ~syndata interp 
                                                                    )) in fun p
                                                             synterp interp
                                                             ?loc ~atts ()
                                                             -> coqpp_body p
                                                             synterp interp
                                                             (Attributes.parse any_attribute atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Export", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           atts = (let _ = 
                                                                  
# 359 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                                          
     EV.export_command (snd p)
  
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 361 "src/coq_elpi_vernacular_syntax.mlg"
        
     let () = ignore_unknown_attributes atts in  
     ()
  
                                                                  )) in fun p
                                                           ?loc ~atts ()
                                                           -> coqpp_body p
                                                           (Attributes.parse any_attribute atts)), Some 
         (fun p -> 
# 359 "src/coq_elpi_vernacular_syntax.mlg"
                                                                       Vernacextend.(VtSideff ([],VtNow)) 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Export", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("As", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil))))), 
         (let coqpp_body p q
         atts = (let _ = 
# 365 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                                                                                 
     EV.export_command ~as_:(snd q) (snd p)
  
                 in Vernactypes.vtdefault (fun () -> 
# 367 "src/coq_elpi_vernacular_syntax.mlg"
        
     let () = ignore_unknown_attributes atts in  
     ()
  
                )) in fun p
         q ?loc ~atts () -> coqpp_body p q
         (Attributes.parse any_attribute atts)), Some (fun p q -> 
# 365 "src/coq_elpi_vernacular_syntax.mlg"
                                                                                              Vernacextend.(VtSideff ([],VtNow)) 
                                                      )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_elpi_cmd_arg)), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           args
                                                           atts = (let syndata = 
                                                                  
# 372 "src/coq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     EV.Synterp.run_program (fst p) (snd p) ~atts args
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 375 "src/coq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.run_program (fst p) (snd p) ~atts ~syndata args 
                                                                  )) in fun p
                                                           args ?loc ~atts ()
                                                           -> coqpp_body p
                                                           args
                                                           (Attributes.parse any_attribute atts)), None))]

let () = Tacentries.tactic_extend "coq-elpi.elpi" "elpi_tac" ~level:0 
         [(Tacentries.TyML (Tacentries.TyIdent ("elpi", Tacentries.TyArg (
                                                        Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                        Tacentries.TyArg (
                                                        Extend.TUlist0 (
                                                        Extend.TUentry (Genarg.get_arg_tag wit_elpi_tactic_arg)), 
                                                        Tacentries.TyNil))), 
           (fun p args ist -> 
# 381 "src/coq_elpi_vernacular_syntax.mlg"
    EV.run_tactic (fst p) (snd p) ~atts:[] ist args 
           )));
         (Tacentries.TyML (Tacentries.TyIdent ("ltac_attributes", Tacentries.TyIdent (":", 
                                                                  Tacentries.TyIdent ("(", 
                                                                  Tacentries.TyArg (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_ltac_attributes), 
                                                                  Tacentries.TyIdent (")", 
                                                                  Tacentries.TyIdent ("elpi", 
                                                                  Tacentries.TyArg (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                  Tacentries.TyArg (
                                                                  Extend.TUlist0 (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_elpi_tactic_arg)), 
                                                                  Tacentries.TyNil)))))))), 
          (fun atts p args ist -> 
# 383 "src/coq_elpi_vernacular_syntax.mlg"
    EV.run_tactic (fst p) (snd p) ~atts ist args 
          )));
         (Tacentries.TyML (Tacentries.TyIdent ("#[", Tacentries.TyArg (
                                                     Extend.TUentry (Genarg.get_arg_tag wit_attributes), 
                                                     Tacentries.TyIdent ("]", 
                                                     Tacentries.TyIdent ("elpi", 
                                                     Tacentries.TyArg (
                                                     Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                     Tacentries.TyArg (
                                                     Extend.TUlist0 (
                                                     Extend.TUentry (Genarg.get_arg_tag wit_elpi_tactic_arg)), 
                                                     Tacentries.TyNil)))))), 
          (fun atts p args ist -> 
# 385 "src/coq_elpi_vernacular_syntax.mlg"
    EV.run_tactic (fst p) (snd p) ~atts ist args 
          )));
         (Tacentries.TyML (Tacentries.TyIdent ("elpi", Tacentries.TyIdent ("query", 
                                                       Tacentries.TyArg (
                                                       Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                                       Tacentries.TyNil))), 
          (fun s ist -> 
# 387 "src/coq_elpi_vernacular_syntax.mlg"
    EV.run_in_tactic s ist 
          )));
         (Tacentries.TyML (Tacentries.TyIdent ("elpi", Tacentries.TyIdent ("query", 
                                                       Tacentries.TyArg (
                                                       Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                       Tacentries.TyArg (
                                                       Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                                       Tacentries.TyNil)))), 
          (fun p s ist -> 
# 389 "src/coq_elpi_vernacular_syntax.mlg"
    EV.run_in_tactic s ~program:(snd p) ist 
          )))]

